<?php
/** ----------------------------------------------------------------------------
 **
 *F checkout_confirmation.php
 **
 ** WEB-Shop Software http://www.webs.de
 **
 **  Generates the "checkout confirmation" page.
 **
 ** ----------------------------------------------------------------------------
 ** based on:
 **  (c) 2000-2001 The Exchange Project (earlier name of osCommerce)
 **  (c) 2002-2003 osCommerce; www.oscommerce.com
 **  (c) 2003 nextcommerce; www.nextcommerce.org
 **  (c) 2006 XT-Commerce
 **
 ** Third Party contributions:
 ** agree_conditions_1.01 Autor: Thomas Plänkers (webmaster@oscommerce.at)
 ** Customers Status v3.x
 ** (c) 2002-2003 Copyright Elari elari@free.fr | www.unlockgsm.com/dload-osc/ |
 ** CVS : http://cvs.sourceforge.net/cgi-bin/viewcvs.cgi/elari/?sortby=date#dirlist
 ** Credit Class/Gift Vouchers/Discount Coupons (Version 5.10)
 ** http://www.oscommerce.com/community/contributions,282
 ** Copyright (c) Strider | Strider@oscworks.com
 ** Copyright (c  Nick Stanko of UkiDev.com, nick@ukidev.com
 ** Copyright (c) Andre ambidex@gmx.net
 ** Copyright (c) 2001,2002 Ian C Wilson http://www.phesis.org
 **
 ** Released under the GNU General Public License
 **
 ** @version $Id: checkout_confirmation.php 2274 2012-07-10 11:22:22Z DocOlson $
 ** @copyright 2012 WEB-Shop Software http://www.webs.de/
 **
 ** ------------------------------------------------------------------------- */
unset($group_check);
include ('includes/application_top.php');
unset($_SESSION['conditions']);
unset($_SESSION['revocation']);

$smarty = new template();
$smarty->caching = 0;

require (DIR_FS_CATALOG . 'templates/' . CURRENT_TEMPLATE . '/source/boxes.php');

require_once (DIR_FS_INC . 'xtc_calculate_tax.inc.php');
require_once (DIR_FS_INC . 'xtc_check_stock.inc.php');
require_once (DIR_FS_INC . 'xtc_display_tax_value.inc.php');

// if the customer is not logged on, redirect them to the login page

if ( !isset ($_SESSION['customer_id']) ) {
	xtc_redirect(xtc_href_link(FILENAME_LOGIN, '', 'SSL'));
}

// if there is nothing in the customers cart, redirect them to the shopping cart page
if ( $_SESSION['cart']->count_contents() < 1 ) {
	xtc_redirect(xtc_href_link(FILENAME_SHOPPING_CART));
}

// avoid hack attempts during the checkout procedure by checking the internal cartID
if ( isset ($_SESSION['cart']->cartID) && isset ($_SESSION['cartID']) ) {
	if ( $_SESSION['cart']->cartID != $_SESSION['cartID'] ) {
		xtc_redirect(xtc_href_link(FILENAME_CHECKOUT_SHIPPING, '', 'SSL'));
	}
}

// if no shipping method has been selected, redirect the customer to the shipping method selection page
if ( !isset ($_SESSION['shipping']) ) {
	xtc_redirect(xtc_href_link(FILENAME_CHECKOUT_SHIPPING, '', 'SSL'));
}
if (isset($_SESSION['tmp_oID'])) {
	unset($_SESSION['tmp_oID']);
}
//check if display conditions on checkout page is true
if ( isset($_POST['payment']) ) {
	$_SESSION['payment'] = xtc_db_prepare_input($_POST['payment']);
}

if ( $_POST['comments_added'] != '' ) {
	$_SESSION['comments'] = xtc_db_prepare_input($_POST['comments']);
}

//-- TheMedia Begin check if display conditions on checkout page is true
if ( isset ($_POST['cot_gv']) ) {
	$_SESSION['cot_gv'] = true;
}

// load the selected payment module
require (DIR_WS_CLASSES . 'payment.php');
$payment_modules = new payment($_SESSION['payment']);

// GV Code ICW ADDED FOR CREDIT CLASS SYSTEM
require (DIR_WS_CLASSES . 'order_total.php');
require (DIR_WS_CLASSES . 'order.php');

$order = new order();

$payment_modules->update_status();

// GV Code Start
$order_total_modules = new order_total();
$order_total_modules->collect_posts();
$order_total_modules->pre_confirmation_check();
// GV Code End

// GV Code line changed
if ((is_array($payment_modules->modules) && (sizeof($payment_modules->modules) > 1) && (!is_object($$_SESSION['payment'])) && (!isset ($_SESSION['credit_covers']))) || (is_object($$_SESSION['payment']) && ($$_SESSION['payment']->enabled == false))) {
	$messageStack->add_session(ERROR_NO_PAYMENT_MODULE_SELECTED);
	xtc_redirect(xtc_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL'));
}

if (is_array($payment_modules->modules)) {
	$payment_modules->pre_confirmation_check();
}
// load the selected shipping module
require (DIR_WS_CLASSES . 'shipping.php');

$shipping_modules = new shipping($_SESSION['shipping']);

// Stock Check
$any_out_of_stock = false;
if (STOCK_CHECK == 'true') {
	for ($i = 0, $n = sizeof($order->products); $i < $n; $i++) {

		if ( xtc_check_stock($order->products[$i]['id'], $order->products[$i]['qty']) ) {
			$any_out_of_stock = true;
		}
	}

	// Out of Stock
	if ( (STOCK_ALLOW_CHECKOUT != 'true') && ($any_out_of_stock == true) ) {
		xtc_redirect(xtc_href_link(FILENAME_SHOPPING_CART));
	}
}

$breadcrumb->add(NAVBAR_TITLE_1_CHECKOUT_CONFIRMATION, xtc_href_link(FILENAME_CHECKOUT_SHIPPING, '', 'SSL'));
$breadcrumb->add(NAVBAR_TITLE_2_CHECKOUT_CONFIRMATION);

//require (DIR_WS_INCLUDES . 'header.php');

if ( SHOW_IP_LOG == 'true' ) {
	$smarty->assign('IP_LOG', 'true');

	if ( $_SERVER["HTTP_X_FORWARDED_FOR"] ) {
		$customers_ip = $_SERVER["HTTP_X_FORWARDED_FOR"];
	} else {
		$customers_ip = $_SERVER["REMOTE_ADDR"];
	}
	$smarty->assign('CUSTOMERS_IP', $customers_ip);
}

$smarty->assign('DELIVERY_LABEL', xtc_address_format($order->delivery['format_id'],
													   $order->delivery, 1, ' ', '<br />'));

if ( $_SESSION['credit_covers'] != '1' ) {
	$smarty->assign('BILLING_LABEL', xtc_address_format($order->billing['format_id'],
														  $order->billing, 1, ' ', '<br />'));
}

$smarty->assign('PRODUCTS_EDIT', xtc_href_link(FILENAME_SHOPPING_CART, '', 'SSL'));
$smarty->assign('SHIPPING_ADDRESS_EDIT', xtc_href_link(FILENAME_CHECKOUT_SHIPPING_ADDRESS, '', 'SSL'));
$smarty->assign('BILLING_ADDRESS_EDIT', xtc_href_link(FILENAME_CHECKOUT_PAYMENT_ADDRESS, '', 'SSL'));

$smarty->assign('CUSTOMER_REFERENCE', $order->info['reference']);
if ( $_SESSION['sendto'] != false ) {
	if ( $order->info['shipping_method'] ) {
		$smarty->assign('SHIPPING_METHOD', $order->info['shipping_method']);
		$smarty->assign('SHIPPING_EDIT', xtc_href_link(FILENAME_CHECKOUT_SHIPPING, '', 'SSL'));
	}
}

for ( $i = 0, $n = sizeof($order->products); $i < $n; $i++ ) {
	$data_products[$i] = $order->products[$i];
	$data_products[$i]['PRODUCTS_ID'] = $data_products[$i]['id'];
	$data_products[$i]['price'] = $xtPrice->xtcFormat($order->products[$i]['final_price'], true);

	if ( (isset ($order->products[$i]['attributes']))
		 && (sizeof($order->products[$i]['attributes']) > 0) ) {

		 for ( $j = 0, $n2 = sizeof($order->products[$i]['attributes']); $j < $n2; $j++ ) {
			$data_products[$i]['attributes'][$j] = $order->products[$i]['attributes'][$j];
		}
	}

	if ( $_SESSION['customers_status']['customers_status_show_price_tax'] == 0
		 && $_SESSION['customers_status']['customers_status_add_tax_ot'] == 1 ) {

		 if ( sizeof($order->info['tax_groups']) > 1 ) {
			$data_products[$i]['price_tax'] = xtc_display_tax_value($order->products[$i]['tax']);
		}
	}
}

$data_products = get_images($data_products);

$smarty_blockshipping = new template();
$smarty_blockshipping->assign('PRODUCTS_BLOCK_SHIPPING_STATUS', ACTIVATE_SHIPPING_STATUS);
$smarty_blockshipping->assign('PRODUCTS_BLOCK_SHIPPING_TIME', SHIPPING_TIME);
$smarty_blockshipping->assign('PRODUCTS_BLOCK', $data_products);
$smarty_blockshipping->assign('language', $_SESSION['language']);
$paymentinfo_content = $smarty_blockshipping->fetch('module/checkout_products_block.html');
$smarty->assign('PRODUCTS_BLOCK', $paymentinfo_content);

if ( $order->info['payment_method'] != 'no_payment'
	 && $order->info['payment_method'] != '' ) {

  // include the template specific files
	include_lang('modules/payment/'.$order->info['payment_method'] . '.php');
	$smarty->assign('PAYMENT_METHOD', constant('MODULE_PAYMENT_'.strtoupper($order->info['payment_method']).'_TEXT_TITLE'));
	if (isset($_GET['payment_error']) && is_object(${$_GET['payment_error']}) && ($error = ${$_GET['payment_error']}->get_error())) {
		$smarty->assign('error', $error['title'].'<br />'.htmlspecialchars( $error['error'],ENT_QUOTES, CHARSET) );
	}
}

$smarty->assign('PAYMENT_EDIT', xtc_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL'));

//$total_block = '<table>';

if (MODULE_ORDER_TOTAL_INSTALLED) {
	$order_total_modules->process();
	$total_block = $order_total_modules->pp_output();
}

//$total_block .= '</table>';
$smarty->assign('TOTAL_BLOCK', $total_block);

if ( is_array($payment_modules->modules) ) {
	if ( $confirmation = $payment_modules->confirmation() ) {

		for ($i = 0, $n = sizeof($confirmation['fields']); $i < $n; $i++) {
			$confirmation['fields'][$i]['field'] = stripslashes($confirmation['fields'][$i]['field']);
		}

		$smarty_payinfo = new template();
		$smarty_payinfo->assign('PAYMENT_INFORMATION', $confirmation);
		$paymentinfo_content = $smarty_payinfo->fetch('module/checkout_payment_info.html');
		$smarty->assign('PAYMENT_INFORMATION', $paymentinfo_content);
	}
}

if ( xtc_not_null($order->info['comments']) ) {
	$smarty->assign('ORDER_COMMENTS',
			nl2br(htmlspecialchars($order->info['comments'], ENT_QUOTES, CHARSET))
			. xtc_draw_hidden_field('comments', htmlspecialchars($order->info['comments'], ENT_QUOTES, CHARSET)));
}

if ( isset ($$_SESSION['payment']->form_action_url) && !$$_SESSION['payment']->tmpOrders ) {
	$form_action_url = $$_SESSION['payment']->form_action_url;
} else {
	$form_action_url = xtc_href_link(FILENAME_CHECKOUT_PROCESS, '', 'SSL');
}

$smarty->assign('CHECKOUT_FORM', xtc_draw_form('form_checkout_confirmation', $form_action_url, 'post'));
$smarty->assign('CHECKOUT_BUTTON', xtc_image_submit('button_confirm_order.gif', IMAGE_BUTTON_CONFIRM_ORDER));
$smarty->assign('FORM_END', '</form>');

$payment_button = '';

if ( is_array($payment_modules->modules) ) {
	$payment_button .= $payment_modules->process_button();
}
$smarty->assign('MODULE_BUTTONS', $payment_button);

if (GROUP_CHECK == 'true') {
	$group_check = 'AND group_ids LIKE \'%c_' . $_SESSION['customers_status']['customers_status_id'] . '_group%\'';
}
//check if display conditions on checkout page is true
if (DISPLAY_CONDITIONS_ON_CHECKOUT == 'true') {
	$shop_content_query = xtc_db_query(
        "-- checkout_payment.php
        SELECT content_title, content_heading, content_text, content_file
        FROM " . TABLE_CONTENT_MANAGER . "
        WHERE content_group = '" . CONDITIONS_ID . "' "
        . $group_check . "
        AND languages_id = '" . $_SESSION['languages_id'] . "'
        LIMIT 1"
    );
	$shop_content_data = xtc_db_fetch_array($shop_content_query);

    if ($shop_content_data['content_file'] != '') {
        $conditions = '<iframe src="' . DIR_WS_CATALOG . 'media/content/' . $shop_content_data['content_file'] . '" width="100%" height="300"></iframe>';
    } else {
        $conditions = '<textarea cols="60" rows="10" readonly="readonly">' . strip_tags(str_replace('<br />', "\n", $shop_content_data['content_text'])) . '</textarea>';
    }

	$smarty->assign('AGB', $conditions);
	$smarty->assign('AGB_checkbox', '<input type="checkbox" value="conditions" name="conditions" />');
	$smarty->assign('AGB_TITLE', ($shop_content_data['content_heading'] ? $shop_content_data['content_heading'] : $shop_content_data['content_title']));
	$smarty->assign('AGB_LINK', xtc_href_link(FILENAME_CONTENT, 'coID=' . CONDITIONS_ID));
}
//check if display revocation on checkout page is true
if(DISPLAY_REVOCATION_ON_CHECKOUT == 'true') {
    $shop_content_query = xtc_db_query(
        "-- checkout_payment.php
        SELECT content_title, content_heading, content_text, content_file
        FROM " . TABLE_CONTENT_MANAGER . "
        WHERE content_group = '" . REVOCATION_ID . "' "
        . $group_check . "
        AND languages_id = '" . $_SESSION['languages_id'] . "'
        LIMIT 1"
    );
    $shop_content_data = xtc_db_fetch_array($shop_content_query);
    if ($shop_content_data != false) {
        if ($shop_content_data['content_file'] != '') {
            $revocation = '<iframe src="' . DIR_WS_CATALOG . 'media/content/' . $shop_content_data['content_file'] . '" width="100%" height="300"></iframe>';
        } else {
            $revocation = '<textarea cols="60" rows="10" readonly="readonly">' . strip_tags(str_replace('<br />', "\n", $shop_content_data['content_text'])) . '</textarea>';
        }
		$smarty->assign('REVOCATION_TITLE', ($shop_content_data['content_heading'] ? $shop_content_data['content_heading'] : $shop_content_data['content_title']));
        $smarty->assign('REVOCATION', $revocation);
        $smarty->assign('REVOCATION_LINK', xtc_href_link(FILENAME_CONTENT, 'coID=' . REVOCATION_ID));
        $smarty->assign('REVOCATION_checkbox', '<input type="checkbox" value="revocation" name="revocation" />');
    }
}

$smarty->assign('PAYMENT_BLOCK', $payment_block);

$main_content = $smarty->fetch('module/checkout_confirmation.html');

include ('includes/application_bottom.php');
