<?php
/** ----------------------------------------------------------------------------
 **
 *F checkout_payment.php
 **
 ** WEB-Shop Software http://www.webs.de
 **
 ** ----------------------------------------------------------------------------
 ** based on:
 **  (c) 2000-2001 The Exchange Project (earlier name of osCommerce)
 **  (c) 2002-2003 osCommerce; www.oscommerce.com
 **  (c) 2003 nextcommerce; www.nextcommerce.org
 **  (c) 2003 XT-Commerce
 **
 ** Third Party contributions:
 ** agree_conditions_1.01 Autor: Thomas Plänkers (webmaster@oscommerce.at)
 ** Customers Status v3.x
 ** (c) 2002-2003 Copyright Elari elari@free.fr | www.unlockgsm.com/dload-osc/ |
 ** CVS : http://cvs.sourceforge.net/cgi-bin/viewcvs.cgi/elari/?sortby=date#dirlist
 ** Credit Class/Gift Vouchers/Discount Coupons (Version 5.10)
 ** http://www.oscommerce.com/community/contributions,282
 ** Copyright (c) Strider | Strider@oscworks.com
 ** Copyright (c  Nick Stanko of UkiDev.com, nick@ukidev.com
 ** Copyright (c) Andre ambidex@gmx.net
 ** Copyright (c) 2001,2002 Ian C Wilson http://www.phesis.org
 **
 ** Released under the GNU General Public License
 **
 ** @version $Id: checkout_payment.php 2274 2012-07-10 11:22:22Z DocOlson $
 ** @copyright 2012 WEB-Shop Software http://www.webs.de/
 **
 ** ------------------------------------------------------------------------- */
include ('includes/application_top.php');
unset($_SESSION['conditions']);
unset($_SESSION['revocation']);

$smarty = new template();
$smarty->caching = 0;
require (DIR_FS_CATALOG . 'templates/' . CURRENT_TEMPLATE . '/source/boxes.php');
require_once (DIR_FS_INC . 'xtc_address_label.inc.php');
require_once (DIR_FS_INC . 'xtc_get_address_format_id.inc.php');
require_once (DIR_FS_INC . 'xtc_check_stock.inc.php');
unset ($_SESSION['tmp_oID']);

// if the customer is not logged on, redirect them to the login page
if (!isset ($_SESSION['customer_id'])) {
    if (ACCOUNT_OPTIONS == 'guest') {
        xtc_redirect(xtc_href_link(FILENAME_CREATE_GUEST_ACCOUNT, '', 'SSL'));
    } else {
        xtc_redirect(xtc_href_link(FILENAME_LOGIN, '', 'SSL'));
    }
}

// if there is nothing in the customers cart, redirect them to the shopping cart page
if ( $_SESSION['cart']->count_contents() < 1 ) {
    xtc_redirect(xtc_href_link(FILENAME_SHOPPING_CART));
}

// if no shipping method has been selected, redirect the customer to the shipping method selection page
// If there are only virtual products, or the shop has no active shipping method, the
// $_SESSION['shipping'] is set to false. http://bugs.webs.de/view.php?id=363
if ( !isset($_SESSION['shipping'])) {
    xtc_redirect(xtc_href_link(FILENAME_CHECKOUT_SHIPPING, '', 'SSL'));
}

// avoid hack attempts during the checkout procedure by checking the internal cartID
if ( isset($_SESSION['cart']->cartID) && isset ($_SESSION['cartID']) ) {
    if ( $_SESSION['cart']->cartID != $_SESSION['cartID'] ) {
        xtc_redirect(xtc_href_link(FILENAME_CHECKOUT_SHIPPING, '', 'SSL'));
    }
}

if ( isset($_SESSION['credit_covers']) ) {
    unset ($_SESSION['credit_covers']);
}

// Stock Check
if ( STOCK_CHECK == 'true' && STOCK_ALLOW_CHECKOUT != 'true' ) {
    $products = $_SESSION['cart']->get_products();
    $any_out_of_stock = 0;

    for ($i = 0, $n = sizeof($products); $i < $n; $i++) {
        if (xtc_check_stock($products[$i]['id'], $products[$i]['quantity']))
        $any_out_of_stock = 1;
    }

    if ( $any_out_of_stock == 1 ) {
        xtc_redirect(xtc_href_link(FILENAME_SHOPPING_CART));
    }
}

// if no billing destination address was selected, use the customers own address as default
if ( !isset ($_SESSION['billto']) ) {
    $_SESSION['billto'] = $_SESSION['customer_default_address_id'];
} else {
    // verify the selected billing address
    $check_address_query = xtc_db_query(
        "SELECT COUNT(*) AS total
        FROM " . TABLE_ADDRESS_BOOK . "
        WHERE customers_id = '" . (int) $_SESSION['customer_id'] . "'
        AND address_book_id = '" . (int) $_SESSION['billto'] . "'"
    );

    $check_address = xtc_db_fetch_array($check_address_query);

    if ( $check_address['total'] != '1' ) {
        $_SESSION['billto'] = $_SESSION['customer_default_address_id'];
        if ( isset ($_SESSION['payment']) ) {
            unset ($_SESSION['payment']);
        }
    }
}

if ( !isset ($_SESSION['sendto']) || $_SESSION['sendto'] == '' ) {
    $_SESSION['sendto'] = $_SESSION['billto'];
}

require (DIR_WS_CLASSES . 'order.php');
$order = new order();

require (DIR_WS_CLASSES . 'order_total.php');
$order_total_modules = new order_total();

$total_weight = $_SESSION['cart']->show_weight();
$total_count = $_SESSION['cart']->count_contents_virtual();

if ($order->billing['country']['iso_code_2'] != '' && $order->delivery['country']['iso_code_2'] == '') {
    $_SESSION['delivery_zone'] = $order->billing['country']['iso_code_2'];
} else {
    $_SESSION['delivery_zone'] = $order->delivery['country']['iso_code_2'];
}

// load all enabled payment modules
require (DIR_WS_CLASSES . 'payment.php');
$payment_modules = new payment;

$order_total_modules->process();
// redirect if Coupon matches ammount

$breadcrumb->add(NAVBAR_TITLE_1_CHECKOUT_PAYMENT, xtc_href_link(FILENAME_CHECKOUT_SHIPPING, '', 'SSL'));
$breadcrumb->add(NAVBAR_TITLE_2_CHECKOUT_PAYMENT, xtc_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL'));

$smarty->assign(
    'FORM_ACTION',
    xtc_draw_form('form_checkout_payment', xtc_href_link(FILENAME_CHECKOUT_CONFIRMATION, '', 'SSL'), 'post')
);

$smarty->assign(
    'ADDRESS_LABEL',
    xtc_address_label($_SESSION['customer_id'], $_SESSION['billto'], true, ' ', '<br />')
);

$smarty->assign(
    'BUTTON_ADDRESS',
    '<a href="' . xtc_href_link(FILENAME_CHECKOUT_PAYMENT_ADDRESS, '', 'SSL') . '">' . xtc_image_button('button_change_address.gif', IMAGE_BUTTON_CHANGE_ADDRESS) . '</a>'
);
$smarty->assign('BUTTON_CONTINUE', xtc_image_submit('button_continue.gif', IMAGE_BUTTON_CONTINUE));
$smarty->assign('BUTTON_CONTINUE_PAYMENT', xtc_image_submit('button_continue_payment.gif', IMAGE_BUTTON_CONTINUE));
$smarty->assign('BUTTON_BACK', '<a href="'.xtc_href_link(FILENAME_CHECKOUT_SHIPPING, '', 'SSL').'">'
								 .xtc_image_button('button_back.gif', IMAGE_BUTTON_BACK).'</a>');
$smarty->assign('FORM_END', '</form>');

$module_smarty = new template();

if ($order->info['total'] > 0) {
    if (
        isset($_GET['payment_error']) &&
        is_object(${ $_GET['payment_error'] }) &&
        ($error = ${$_GET['payment_error']}->get_error())
    ) {
        $smarty->assign('error', htmlspecialchars($error['error']));
    }

    // Paypal Express Modul Start
    if(isset($_SESSION['reshash']['FORMATED_ERRORS'])){
        $smarty->assign('error', $_SESSION['reshash']['FORMATED_ERRORS']);
    }
    // Paypal Express Modul Ende

    $selection = $payment_modules->selection();

    $radio_buttons = 0;
    for ($i = 0, $n = sizeof($selection); $i < $n; $i++) {

        $selection[$i]['radio_buttons'] = $radio_buttons;
        if (($selection[$i]['id'] == $_SESSION['payment']) || ($n == 1)) {
            $selection[$i]['checked'] = 1;
        }

        if (sizeof($selection) > 1) {
            $selection[$i]['selection'] = xtc_draw_radio_field('payment', $selection[$i]['id'], $selection[$i]['checked']);
        } else {
            $selection[$i]['selection'] = xtc_draw_hidden_field('payment', $selection[$i]['id']);
        }

        if ( !isset($selection[$i]['error']) ) {
            $radio_buttons++;
        }
    }

    $module_smarty->assign('module_content', $selection);

} else {
    $smarty->assign('GV_COVER', 'true');
}

// Paypal Express Modul Start
// PayPal neuer Start auf jeden Fall
unset($_SESSION['reshash']);
unset($_SESSION['nvpReqArray']);
// Paypal Express Modul Ende


if (ACTIVATE_GIFT_SYSTEM == 'true') {
    $smarty->assign('module_gift', $order_total_modules->credit_selection());
}

$module_smarty->caching = 0;
$payment_block = $module_smarty->fetch('module/checkout_payment_block.html');

$smarty->assign('COMMENTS', xtc_draw_textarea_field('comments', 'soft', '60', '5', $_SESSION['comments']) . xtc_draw_hidden_field('comments_added', 'YES'));
$smarty->assign('PAYMENT_BLOCK', $payment_block);

$main_content = $smarty->fetch('module/checkout_payment.html');

include ('includes/application_bottom.php');
